<template>
  <div class="app-container">
    <el-card class="box-card app-container">
      <el-row slot="header">
        <el-col :span="20">
          <h3>{{ title }}</h3>
        </el-col>
        <el-col :span="4">
          <el-button type="primary" class="fr" @click="submit">
            Guardar
          </el-button>
        </el-col>
      </el-row>
      <el-form class="form" ref="fields" :rules="rules" :model="fields" label-position="top">
        <el-row :gutter="20">
          <el-col :span="4">
            <el-form-item label="Fecha Entrega" prop="deliveryDate" :error="errors.deliveryDate">
              <el-date-picker
                v-model.trim="fields.deliveryDate"
                type="date"
                format="dd/MM/yyyy"
                placeholder="Fecha de Entrega">
              </el-date-picker>
            </el-form-item>
          </el-col>
          <el-col :span="18">
            <el-form-item label="Cliente" prop="client" :error="errors.client">
              <app-select-related v-model="fields.client"
                                  placeholder="Nombre del cliente"
                                  @input="updateClientRelated"
                                  searchFieldName="name"
                                  :service="clientsService"
              />
            </el-form-item>
          </el-col>
        </el-row>
        <el-row :gutter="20">
          <!-- Order State -->
          <el-col :span="4">
            <el-form-item prop="state" :error="errors.state">
              <template slot="label">
                Estado
                <el-popover placement="right" trigger="hover" width="400" >
                  <el-table size="mini" :data="statesDescription()">
                    <el-table-column width="100" prop="name" label="Estado" />
                    <el-table-column prop="description" label="Descripción" />
                  </el-table>
                  <font-awesome-icon slot="reference" icon="question-circle" />
                </el-popover>
              </template>
              <el-select v-model="fields.state"
                         placeholder="Estado">
                <el-option
                  v-for="(state, idx) in orderStates"
                  :key="idx"
                  :label="$t(state)"
                  :value="state">
                </el-option>
              </el-select>
            </el-form-item>
          </el-col>
          <!-- End Order State -->
          <el-col :span="18">
            <el-form-item label="Vendedor" prop="salesman" :error="errors.salesman">
              <el-select
                v-model="fields.salesman"
                filterable
                placeholder="Vendedor">
                <el-option
                  v-for="salesman in salesmen"
                  :key="salesman._id"
                  :label="salesman.name"
                  :value="salesman._id">
                </el-option>
              </el-select>
            </el-form-item>
          </el-col>
        </el-row>
        <el-row :gutter="20">
          <el-col :span="4">
            <el-form-item label="Descuento (%)" prop="discount" :error="errors.discount">
              <el-input-number v-model.trim="fields.discount" :min="0" :max="100" :placeholder="0.0">
              </el-input-number>
            </el-form-item>
          </el-col>
          <el-col :span="8">
            <el-form-item label="Lista de Precios">
              <el-select
                v-model="selectedPrice"
                placeholder="Lista de Precios">
                <el-option
                  v-for="(priceOption, optionName) in priceOptions"
                  :key="optionName"
                  :label="priceOption"
                  :value="optionName">
                </el-option>
              </el-select>
            </el-form-item>
          </el-col>
        </el-row>

        <h3>Productos</h3>
        <app-items-table v-model="fields.items" :discount="fields.discount" :selectedPrice="selectedPrice" />

      </el-form>
    </el-card>
  </div>
</template>

<script>
import api from "@/feathers";
import orderStates from "@/services/order-states";
import BaseForm from "@/common/base-form.mixin";
import AppSelectRelated from "@/common/select-related";
import AppItemsTable from "@/common/items-table";

const CLIENT_CATEGORY_TO_PRICE = {
  Distribuidor: "distributorPrice"
};

export default {
  name: "user-form",
  mixins: [BaseForm],
  props: {
    id: { type: String, required: false, default: null }
  },
  components: {
    AppItemsTable,
    AppSelectRelated
  },
  data() {
    const rules = {
      deliveryDate: [
        {
          required: true,
          message: "Debe ingresar una fecha de entrega",
          trigger: "blur"
        }
      ],
      client: [
        { required: true, message: "Debe ingresar un cliente", trigger: "blur" }
      ],
      state: [
        {
          required: true,
          message: "Debe ingresar un estado para el pedido",
          trigger: "blur"
        }
      ],
      salesman: [
        {
          required: true,
          message: "Debe ingresar un vendedor",
          trigger: "blur"
        }
      ],
      discount: [
        {
          type: "number",
          message: "Debe ingresar un valor numérico",
          trigger: "blur"
        }
      ]
    };

    return {
      title: "",
      rules,
      errors: {},
      fields: {
        items: []
      },
      filteredClients: [],
      orderStates: [],
      priceOptions: {
        price: "Minorista",
        wholesalerPrice: "Mayorista",
        distributorPrice: "Distribuidor",
        noReturnsPrice: "Sin Devoluciones"
      },
      salesmen: [],
      selectedPrice: "price"
    };
  },
  created() {
    this.initialize();
  },
  methods: {
    async initialize() {
      this.clientsService = api.service("clients");
      this.productsService = api.service("products");
      this.service = api.service("orders");

      const { fields, errors } = this.buildForm(this.rules);
      fields.discount = fields.discount || 0;
      fields.state = fields.state || "draft";
      fields.items = fields.items || [];
      this.fields = fields;
      this.errors = errors;

      this.orderStates = orderStates.getStates();
      this.salesmen = await this.getSalesmen();

      if (this.id) {
        this.fields = await this.service.get(this.id);
        this.action = "update";
        this.title = `Actualizar Pedido`;
      } else {
        this.action = "create";
        this.title = "Nuevo Pedido";
      }
    },
    statesDescription() {
      return orderStates.getDescription();
    },
    async getSalesmen() {
      return await api.service("salesmen").find({ query: { $limit: -1 } });
    },
    async filterClients(filterName) {
      const query = { name: { $search: filterName } };
      const clients = await this.clientsService.find({ query });
      this.filteredClients = clients.data;
    },
    async updateClientRelated(clientId) {
      if (clientId) {
        const client = await this.clientsService.get(clientId);
        this.fields.discount = client.defaultDiscount;
        const selectedPrice = CLIENT_CATEGORY_TO_PRICE[client.category];
        this.selectedPrice = selectedPrice || "price";
      }
    }
  }
};
</script>

<style lang="scss">
.el-card {
  &__header {
    margin: 0;
    padding: 10px 20px 4px 20px;
    h3 {
      margin: 0;
      padding: 10px 0px;
    }
  }
}
</style>
